# $Revision: 1.98 $, $Date: 2008/09/27 23:07:13 $
#
# Conditional build:
%bcond_without	selinux		# build without SELinux support
%bcond_without	initrd		# don't build initrd version
%bcond_without	uclibc
#
%ifarch sparc sparcv9 sparc64
%undefine with_uclibc
%endif

Summary:	Userspace support for the device-mapper
Summary(pl.UTF-8):	Wsparcie dla mapowania urządzeń w przestrzeni użytkownika
Name:		device-mapper
Version:	1.02.28
Release:	1
License:	LGPL v2.1 (library), GPL v2 (executables)
Group:		Applications/System
Source0:	ftp://sources.redhat.com/pub/dm/%{name}.%{version}.tgz
# Source0-md5:	c9ae0776994a419f9e1ba842164bb626
# http://www.redhat.com/archives/dm-devel/2005-March/msg00022.html
Patch1:		%{name}-klibc.patch
Patch2:		%{name}-getopt.patch
Patch4:		%{name}-force-local-headers.patch
Patch5:		%{name}-linking.patch
Patch6:		%{name}-dmsetup-export.patch
URL:		http://sources.redhat.com/dm/
BuildRequires:	autoconf
BuildRequires:	automake
%{?with_initrd:BuildRequires:	klibc-static >= 1.5-2}
%{?with_selinux:BuildRequires:	libselinux-devel >= 1.10}
%if %{with initrd} && %{with uclibc}
BuildRequires:	uClibc-static >= 2:0.9.26
%endif
%{?with_selinux:Requires:	libselinux >= 1.10}
Conflicts:	dev < 2.9.0-8
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%undefine	configure_cache
%define		_sbindir	/sbin

%description
The goal of this driver is to support volume management. The driver
enables the definition of new block devices composed of ranges of
sectors of existing devices. This can be used to define disk
partitions - or logical volumes. This light-weight kernel component
can support user-space tools for logical volume management.

%description -l pl.UTF-8
Celem tego sterownika jest obsługa zarządzania wolumenami. Sterownik
włącza definiowanie nowych urządzeń blokowych złożonych z przedziałów
sektorów na istniejących urządzeniach. Może to być wykorzystane do
definiowania partycji na dysku lub logicznych wolumenów. Ten lekki
składnik jądra może wspierać działające w przestrzeni użytkownika
narzędzia do zarządzania logicznymi wolumenami.

%package initrd
Summary:	Userspace support for the device-mapper - static dmsetup for initrd
Summary(pl.UTF-8):	Wsparcie dla mapowania urządzeń w przestrzeni użytkownika - statyczne dmsetup dla initrd
License:	GPL v2
Group:		Applications/System
Requires:	%{name} = %{version}-%{release}

%description initrd
Userspace support for the device-mapper - static dmsetup binary for
initrd.

%description initrd -l pl.UTF-8
Wsparcie dla mapowania urządzeń w przestrzeni użytkownika - statyczna
wersja dmsetup dla initrd.

%package devel
Summary:	Header files and development documentation for %{name}
Summary(pl.UTF-8):	Pliki nagłówkowe i dokumentacja do %{name}
License:	LGPL v2.1
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
%if %{with selinux}
Requires:	libselinux-devel
Requires:	libsepol-devel
%endif

%description devel
Header files and development documentation for %{name}.

%description devel -l pl.UTF-8
Pliki nagłówkowe i dokumentacja do %{name}.

%package static
Summary:	Static devmapper library
Summary(pl.UTF-8):	Statyczna biblioteka devmapper
License:	LGPL v2.1
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static devmapper library.

%description static -l pl.UTF-8
Statyczna biblioteka devmapper.

%package initrd-devel
Summary:	Static devmapper library and header files for initrd applications
Summary(pl.UTF-8):	Statyczna biblioteka devmapper i jej pliki nagłówkowe dla aplikacji initrd
License:	LGPL v2.1
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}
Requires:	klibc

%description initrd-devel
Static devmapper library and its header files for initrd applications
linked with klibc.

%description initrd-devel -l pl.UTF-8
Statyczna, zlinkowana z klibc biblioteka devmapper oraz jej pliki
nagłówkowe dla aplikacji używanych w initrd.

%package scripts
Summary:	Additional scripts
Summary(pl.UTF-8):	Dodatkowe skrypty
License:	GPL v2
Group:		Applications/System
Requires:	%{name} = %{version}-%{release}
Requires:	util-linux

%description scripts
Additional scripts.

%description scripts -l pl.UTF-8
Dodatkowe skrypty.

%prep
%setup -q -n %{name}.%{version}
%patch1 -p1
%patch2 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1

%build
cp -f /usr/share/automake/config.sub autoconf
%{__aclocal}
%{__autoconf}

%if %{with initrd}
# klibc
%configure \
	CC="klcc -static" \
	CLDFLAGS="%{rpmldflags}" \
	--disable-selinux \
	--enable-static_link \
	--with-optimisation="%{rpmcflags}" \
	--with-user=%(id -u) \
	--with-group=%(id -g) \
	--with-interface=ioctl \
	--disable-nls
sed -i -e 's#rpl_malloc#malloc#g' include/configure.h
# On AC it successfully finds canonicalize_file_name() from glibc's libc.a
# On TH it it fails to do anything with libc.a due link errors (undefined reference to `_Unwind_Resume', undefined reference to `__gcc_personality_v0', ...)
# really it should check func from klibc libc.a
sed -i -e 's,#define HAVE_CANONICALIZE_FILE_NAME 1,#undef HAVE_CANONICALIZE_FILE_NAME,' include/configure.h
%{__make}

cp -a dmsetup/dmsetup.static initrd-dmsetup
cp -a lib/ioctl/libdevmapper.a initrd-libdevmapper-klibc.a
%{__make} clean

%if %{with uclibc}
# uclibc (for lvm2)
%configure \
	CC="%{_target_cpu}-uclibc-gcc" \
	CLDFLAGS="%{rpmldflags}" \
	--disable-selinux \
	--with-optimisation="-Os" \
	--with-interface=ioctl \
	--disable-nls
sed -i -e 's#rpl_malloc#malloc#g' include/configure.h
%{__make}

cp -a lib/ioctl/libdevmapper.a initrd-libdevmapper-uclibc.a
%{__make} clean
%endif
%endif

%configure \
	CLDFLAGS="%{rpmldflags}" \
	--%{?with_selinux:en}%{!?with_selinux:dis}able-selinux \
	--with-optimisation="%{rpmcflags}" \
	--with-user=%(id -u) \
	--with-group=%(id -g) \
	--with-interface=ioctl \
	--enable-dmeventd \
	--enable-pkgconfig \
	--disable-klibc
%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/%{_lib},%{_libdir}/%{name}}

%{__make} install \
	usrlibdir="$RPM_BUILD_ROOT%{_libdir}" \
	DESTDIR=$RPM_BUILD_ROOT

SONAME=$(basename $RPM_BUILD_ROOT%{_libdir}/libdevmapper.so.*.*)
ln -sf /%{_lib}/${SONAME} $RPM_BUILD_ROOT%{_libdir}/libdevmapper.so
SONAME=$(basename $RPM_BUILD_ROOT%{_libdir}/libdevmapper-event.so.*.*)
ln -sf /%{_lib}/${SONAME} $RPM_BUILD_ROOT%{_libdir}/libdevmapper-event.so
mv -f $RPM_BUILD_ROOT%{_libdir}/lib*.so.*.* $RPM_BUILD_ROOT/%{_lib}
install scripts/* $RPM_BUILD_ROOT%{_libdir}/%{name}

install lib/ioctl/libdevmapper.a $RPM_BUILD_ROOT%{_libdir}
install dmeventd/libdevmapper-event.a $RPM_BUILD_ROOT%{_libdir}

%if %{with initrd}
install -d $RPM_BUILD_ROOT/usr/{{%{_lib},include}/klibc,%{_target_cpu}-linux-uclibc/usr/{lib,include}}
install initrd-dmsetup $RPM_BUILD_ROOT%{_sbindir}
install initrd-libdevmapper-klibc.a $RPM_BUILD_ROOT/usr/%{_lib}/klibc/libdevmapper.a
install include/libdevmapper.h $RPM_BUILD_ROOT/usr/include/klibc
%if %{with uclibc}
install initrd-libdevmapper-uclibc.a $RPM_BUILD_ROOT/usr/%{_target_cpu}-linux-uclibc/usr/lib/libdevmapper.a
install include/libdevmapper.h $RPM_BUILD_ROOT/usr/%{_target_cpu}-linux-uclibc/usr/include
%endif
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc INTRO INSTALL README
%attr(755,root,root) %{_sbindir}/dmeventd
%attr(755,root,root) %{_sbindir}/dmsetup
%attr(755,root,root) /%{_lib}/libdevmapper.so.*.*
%attr(755,root,root) /%{_lib}/libdevmapper-event.so.*.*
%{_mandir}/man8/dmsetup.8*

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libdevmapper.so
%attr(755,root,root) %{_libdir}/libdevmapper-event.so
%{_includedir}/libdevmapper*.h
%{_pkgconfigdir}/devmapper.pc
%{_pkgconfigdir}/devmapper-event.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/libdevmapper.a
%{_libdir}/libdevmapper-event.a

%files scripts
%defattr(644,root,root,755)
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/*

%if %{with initrd}
%files initrd
%defattr(644,root,root,755)
%attr(755,root,root) %{_sbindir}/initrd-dmsetup

%files initrd-devel
%defattr(644,root,root,755)
%{_prefix}/%{_lib}/klibc/libdevmapper.a
%{_includedir}/klibc/libdevmapper.h
%if %{with uclibc}
%{_prefix}/%{_target_cpu}-linux-uclibc/usr/lib/libdevmapper.a
%{_prefix}/%{_target_cpu}-linux-uclibc/usr/include/libdevmapper.h
%endif
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: device-mapper.spec,v $
Revision 1.98  2008/09/27 23:07:13  charles
- updated to 1.02.28

Revision 1.97  2008/07/19 13:44:55  glen
- release 2

Revision 1.96  2008/07/15 07:27:42  arekm
- up to 1.02.27; -disable_dynamic_link.patch looks useless

Revision 1.95  2008/06/22 19:54:57  arekm
- rel 2; devel R: libselinux-devel and sepol-devel when building with selinux

Revision 1.94  2008-04-14 20:49:04  arekm
- up to 1.02.25

Revision 1.93  2008-04-03 17:50:17  glen
- release 3

Revision 1.92  2008-04-03 17:47:44  glen
- release 2

Revision 1.91  2008-04-01 19:05:45  glen
- uClibc epoch is 2 already since 0.9.20

Revision 1.90  2007-12-16 22:49:36  qboosh
- updated to 1.02.23
- updated disable_dynamic_link patch
- BR klibc with fixed klcc, dropped BC

Revision 1.89  2007-10-25 21:58:12  glen
- patch from suse to add dmsetup export command

Revision 1.88  2007/10/23 16:02:08  glen
- minimum klibc version from pld that is able to compile initrd parts (missing isspace())

Revision 1.87  2007/10/23 15:52:18  glen
- workaround to get device-mapper-initrd on ac system

Revision 1.86  2007/09/17 15:34:48  baggins
- rel 2

Revision 1.85  2007/09/10 15:39:53  tommat
- no uclibc on sparcs for now

Revision 1.84  2007/09/09 22:42:32  qboosh
- updated to 1.02.22
- updated klibc patch
- clarified License, simplified symlinks creation
- dropped scripts from base docs (already included in separate package)

Revision 1.83  2007/06/30 18:38:15  arekm
- up to 1.02.20

Revision 1.82  2007/06/07 16:06:40  arekm
- rel 4

Revision 1.81  2007/06/02 21:37:33  arekm
- damn, uclibc version needed for lvm2

Revision 1.80  2007/06/02 21:30:30  arekm
- rel 2

Revision 1.79  2007/06/02 21:29:59  arekm
- disable uclibc by default

Revision 1.78  2007/05/01 13:33:09  qboosh
- updated to 1.02.19

Revision 1.77  2007/02/20 20:22:17  arekm
- rel 2; enable pkgconfig

Revision 1.76  2007/02/16 09:46:27  arekm
- rel 1

Revision 1.75  2007/02/16 08:31:43  arekm
- up to 1.02.18

Revision 1.74  2007/02/12 21:23:52  glen
- tabs in preamble

Revision 1.73  2007/02/12 00:48:45  baggins
- converted to UTF-8

Revision 1.72  2007/02/04 18:38:18  qboosh
- updated klibc BC
- package dmeventd

Revision 1.71  2007/02/04 15:13:57  areq
- 1.02.17

Revision 1.70  2006/12/09 22:18:12  qboosh
- updated to 1.02.13

Revision 1.69  2006/11/19 00:22:09  qboosh
- updated to 1.02.12

Revision 1.68  2006/10/05 21:23:42  qboosh
- updated to 1.02.10

Revision 1.67  2006/09/27 18:28:59  sparky
- rel 0.3 - updated klibc patch; STBR try 2

Revision 1.66  2006/09/27 14:14:22  sparky
- fix libdevmapper-event.so linking
- rel 0.2, STBR for Th now !

Revision 1.65  2006/08/22 21:02:58  qboosh
- updated to 1.02.09, updated klibc patch

Revision 1.64  2006/08/02 00:02:38  sparky
- sed moved to patch

Revision 1.63  2006/07/30 19:05:59  sparky
- CLDFLAGS="%{rpmldflags}"

Revision 1.62  2006/07/19 16:39:50  qboosh
- updated to 1.02.08

Revision 1.61  2006/07/12 17:09:15  glen
- add buildconflicts not to collide with older libdevmapper.h

Revision 1.60  2006/07/01 11:24:23  qboosh
- added ac patch

Revision 1.59  2006/06/20 16:40:56  wiget
- don't use %{_lib} in uClibc path
- release 0.17

Revision 1.58  2006/06/20 10:15:14  pluto
- release 0.16 for rebuild with new uClibc.

Revision 1.57  2006/05/21 15:23:22  glen
- really build with uclibc
- copy correct configure args

Revision 1.56  2006/05/21 14:26:55  glen
- build also uclibc version of initrd-devel (for lvm2)

Revision 1.55  2006/05/20 12:33:40  glen
- --disable-nls for initrd (from lvm2.spec)

Revision 1.54  2006/05/17 17:55:25  qboosh
- updated to 1.02.07, updated patches
- fixed libdevmapper-event packaking

Revision 1.53  2006/05/16 20:36:16  glen
- install real libdevmapper.a, not some manually partially assembed one

Revision 1.52  2006/05/16 20:23:06  glen
- avoid libdevmapper.so being pointing to libdevmapper-event.so.1.02
- and one subshell less

Revision 1.51  2006/05/16 20:12:06  glen
- disable configure_cache as configure is ran twice with different CFLAGS

Revision 1.50  2006/04/22 22:12:48  qboosh
- workaround not to require Linux >= 2.6.16 headers for klibc

Revision 1.49  2006/04/22 18:56:23  arekm
- builds

Revision 1.48  2006/04/22 18:44:26  arekm
- partially updated

Revision 1.47  2006/01/24 23:02:00  maciek2w
- fix:getopt_long removed from klibc
- STBR for Th

Revision 1.46  2005/10/06 20:31:12  qboosh
- License is strictly GPL v2
  (some library components are on LGPL v2.1, but the rest enforces GPL v2)

Revision 1.45  2005/10/06 20:28:56  qboosh
- updated to 1.01.05
- updated for current klibc (BR: klibc-static, use "klcc -static" as CC)
  note: recent kernel-headers (2.6.12 or so) are needed for klibc to build dm

Revision 1.44  2005/08/11 19:44:55  wrobell
- fixed initrd bcond

Revision 1.43  2005/08/06 15:17:07  qboosh
- updated to 1.01.04

Revision 1.42  2005/08/02 20:07:01  qboosh
- wrapped, pl fix

Revision 1.41  2005/07/31 17:54:48  jajcus
- klibc used instead of uClibc for dmsetup-initrd compilation
- device-mapper-initrd-devel subpackage added

Revision 1.40  2005/07/31 15:12:40  jajcus
- Release: 2
- initrd subpackage (statically linked, using uClibc on ix86 and without selinux support) added
- without_selinux bcond fixed

Revision 1.39  2005/06/18 17:55:45  areq
- 1.01.03

Revision 1.38  2005/05/21 20:02:36  qboosh
- cosmetics

Revision 1.37  2005/05/21 19:08:43  speedy
- new package: -scripts

Revision 1.36  2005/05/21 18:18:12  speedy
- release 2
- make scripts %doc (kill dep on perl-base, scripts are optional...
  not required by /sbin/dmsetup)

Revision 1.35  2005/05/21 15:18:15  qboosh
- updated to 1.01.02

Revision 1.34  2005/04/06 19:44:21  paszczus
- updated to 1.01.01

Revision 1.33  2005/01/15 21:38:50  qboosh
- updated to 1.0.21, added stack patch (remove weird "stack;" from code)

Revision 1.32  2004/11/19 21:23:18  glen
- added selinux bcond; rel 2; STBR

Revision 1.31  2004/11/17 20:46:05  pluto
- %install fixed.

Revision 1.30  2004/07/03 20:21:51  arekm
- updated to 1.00.19; opt patch obsolete

Revision 1.29  2004/06/22 21:20:11  qboosh
- new libselinux is required at runtime

Revision 1.28  2004/06/20 17:01:44  arekm
- updated to 1.00.18

Revision 1.27  2004/05/06 17:14:59  qboosh
- fixed opt patch (allow passing our optflags, not only remove hardcoded -O2)

Revision 1.26  2004/05/06 14:01:01  qboosh
- kernel version is needed only for kernel part, which is not built anyway,
  so dropped _kernel_ver and co.
- strict internal deps, release 3

Revision 1.25  2004/04/26 14:31:22  baggins
- release 2
- conflicts with dev without /dev/mapper/control

Revision 1.24  2004/04/23 17:28:52  arekm
- updated to 1.00.17

Revision 1.23  2004/04/01 00:51:24  arekm
- added url

Revision 1.22  2004/04/01 00:40:04  arekm
- fix .so symlink

Revision 1.21  2004/04/01 00:08:03  arekm
- version 1.00.09

Revision 1.20  2004/03/17 12:11:15  andree
- lib -> %{_lib}
- added scripts/* to files

Revision 1.19  2004/03/05 14:17:13  arekm
- drop --with-kernel-dir (fixes build problems) - cieciwa + drop errno patch, sorry

Revision 1.18  2004/03/05 14:16:07  andree
- fix build (patch2)

Revision 1.17  2004/03/05 12:56:18  andree
- copy config.sub

Revision 1.16  2003/11/29 00:17:10  qboosh
- it uses _kernel_ headers during build

Revision 1.15  2003/11/28 21:55:17  qboosh
- added opt patch

Revision 1.14  2003/11/22 21:11:56  arekm
- updated to 1.00.07

Revision 1.13  2003/09/11 07:51:54  qboosh
- -static descriptions

Revision 1.12  2003/09/11 00:24:21  wiget
- make libdevmapper.a (needed to build static lvm used on initrd)

Revision 1.11  2003/09/10 21:48:50  arekm
- updated to 1.00.05

Revision 1.10  2003/08/20 23:44:04  arekm
- updated to 1.00.03

Revision 1.9  2003/08/18 08:08:00  gotar
- mass commit: cosmetics (removed trailing white spaces)

Revision 1.8  2003/07/18 22:25:22  arekm
- updated to 1.00.02

Revision 1.7  2003/07/08 00:05:10  blues
- second part of small fixes inspired by kloczek (this time better checked,
  I hope...)

Revision 1.6  2003/05/26 16:24:53  malekith
- massive attack: adding Source-md5

Revision 1.5  2003/05/25 05:46:43  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.4  2003/05/10 14:40:48  wiget
- fix building with not-running kernel

Revision 1.3  2003/04/21 01:13:52  qboosh
- pl description, BR: ac,am

Revision 1.2  2003/04/15 16:16:52  baggins
- should work now

Revision 1.1  2003/04/15 15:57:01  baggins
- initial revision
